-- name: \\#FDD017\\Coin Store\\#FFFFFF\\
-- description: Press D pad Up to open store, left/right Cycle Items, and down to buy and spawn item




local Walletamount = 0
local CurrentTexture = get_texture_info('Storeitem0')
local Currentselecteditem = 0
local Moonjumpactive = false
shopisopen = false
local pricetext = "0"


-- big/small mario vars
local BigmarioTimer = 0  -- Timer to track how long the message should stay
local BigmarioDuration = 300 * 30  -- 30 seconds (30 frames per second * 30)
local minimarioTimer = 0
local minimarioDuration = 300 * 30  -- 30 seconds (30 frames per second * 30)
local prev_area = 1
justtouchedtree = false


function Storemenu(m)
    -- Handle Moon Jump activation
    if (m.controller.buttonDown & D_JPAD) ~= 0 and Moonjumpactive then
        m.particleFlags = PARTICLE_SPARKLES | PARTICLE_DUST
        m.vel.y = 25
    else
        Moonjumpactive = false
    end
    if is_game_paused() then
        shopisopen = false

    end
    -- Handle shop item selection
    if shopisopen then
        if (m.controller.buttonPressed & L_JPAD) ~= 0 then
            Currentselecteditem = math.max(Currentselecteditem - 1, 0)  -- Prevent negative index
        end
        if (m.controller.buttonPressed & R_JPAD) ~= 0 then
            Currentselecteditem = (Currentselecteditem + 1) % 25  -- Loops back to 0 when reaching 22
        end
    end

   




end




function SpawnItem(m)
    if BigmarioTimer > 0 then
     
        BigmarioTimer = BigmarioTimer - 1
        m.invincTimer = 1
        m.health = 0x800
        m.marioObj.header.gfx.scale.x = 4
        m.marioObj.header.gfx.scale.y = 4
        m.marioObj.header.gfx.scale.z = 4
        big_mario_instant_kill(m)
    elseif minimarioTimer > 0 then

        if m.faceAngle.x == 0 then
        m.vel.y = m.vel.y + 1
        end

        



        peakHeight = 0
        minimarioTimer = minimarioTimer - 1
        m.marioObj.header.gfx.scale.x = 0.4
        m.marioObj.header.gfx.scale.y = 0.4
        m.marioObj.header.gfx.scale.z = 0.4
        m.hurtCounter = 0
       
        if m.area.index ~= prev_area then
            m.peakHeight = m.peakHeight + 32000 * (prev_area - m.area.index)
            prev_area = m.area.index
        end

    else
        m.marioObj.header.gfx.scale.x = 1
        m.marioObj.header.gfx.scale.y = 1
        m.marioObj.header.gfx.scale.z = 1
    end


if (m.controller.buttonPressed & D_JPAD) ~= 0 then
        -- Down button spawn action   
if Currentselecteditem == 0 then
                    --nul             
elseif Currentselecteditem == 1 then
                       -- Make it rain!!!
                       if Walletamount >= 1 then
             spawn_sync_object(
                id_bhvSingleCoinGetsSpawned,
                E_MODEL_YELLOW_COIN,
                m.pos.x + 150, m.pos.y, m.pos.z,
                nil)
                           Walletamount = Walletamount - 1
                       else
                           play_character_sound(m,  CHAR_SOUND_DOH)
                       end
elseif Currentselecteditem == 2 then
                   --throwbox
                    pricetext = "3"
                    CurrentTexture = get_texture_info('Storeitem2')
                    if Walletamount >= 3 then
                 -- spawn small breakable box in hand
                  local obj = spawn_sync_object(
            id_bhvBreakableBoxSmall,
            E_MODEL_BREAKABLE_BOX_SMALL,
            m.pos.x, m.pos.y, m.pos.z,

            function(obj)
                obj.oBehParams2ndByte = 0
                obj.oOpacity = 255
                obj.oFlags = OBJ_FLAG_HOLDABLE
                obj.oInteractType = obj.oInteractType | INTERACT_GRABBABLE
            end)
        if obj ~= nil then
            m.usedObj = obj
            mario_grab_used_object(m)
            m.marioBodyState.grabPos = GRAB_POS_LIGHT_OBJ
            set_mario_action(m, ACT_HOLD_IDLE, 0)
        end    
                       Walletamount = Walletamount - 3
                   else
                       play_character_sound(m,  CHAR_SOUND_DOH)
                   end
                   elseif Currentselecteditem == 3 then
                   -- Jump Box
                   pricetext = "5"
                   CurrentTexture = get_texture_info('Storeitem3')
                   if Walletamount >= 5 then
           -- spawn small breakable box in hand 
           local obj = spawn_sync_object(
            id_bhvJumpingBox,
            E_MODEL_BREAKABLE_BOX_SMALL,
            m.pos.x, m.pos.y, m.pos.z,
            function(obj)
                obj.oBehParams2ndByte = 0
                obj.oOpacity = 255
                obj.oFlags = OBJ_FLAG_HOLDABLE
                obj.oInteractType = obj.oInteractType | INTERACT_GRABBABLE
            end)
        if obj ~= nil then
            m.usedObj = obj
            mario_grab_used_object(m)
            m.marioBodyState.grabPos = GRAB_POS_LIGHT_OBJ
            set_mario_action(m, ACT_HOLD_IDLE, 0)
        end
        Walletamount = Walletamount - 5
    else
        play_character_sound(m,  CHAR_SOUND_DOH)
    end    
elseif Currentselecteditem == 4 then
                       --HP
                       if Walletamount >= 8 and m.health ~= 0x880 then
                           m.health = 0x880
       
                           Walletamount = Walletamount - 8
                       
                       else
                           play_character_sound(m,  CHAR_SOUND_DOH)
       
                       end
elseif Currentselecteditem == 5 then
                       --Goomba
                       if Walletamount >= 10 then
                     -- spawn goomba
        spawn_sync_object(
            id_bhvGoomba,
            E_MODEL_GOOMBA,
            m.pos.x + 150, m.pos.y, m.pos.z,
            nil)       
                           Walletamount = Walletamount - 10
       
                       else
                           play_character_sound(m,  CHAR_SOUND_DOH)
                       end
elseif Currentselecteditem == 6 then
                       --custom Goomba
                       if Walletamount >= 10 then
                        -- spawn goomba
           spawn_sync_object(
            id_bhvCustomGoomba,
               E_MODEL_GOOMBA,
               m.pos.x + 250, m.pos.y, m.pos.z,
               nil)       
                              Walletamount = Walletamount - 10
          
                          else
                              play_character_sound(m,  CHAR_SOUND_DOH)
                          end
elseif Currentselecteditem == 7 then
         --bomb
    if Walletamount >= 12 then
        -- spawn bobomb in hand
        local obj = spawn_sync_object(
            id_bhvBobomb,
            E_MODEL_BOBOMB_BUDDY,
            m.pos.x, m.pos.y, m.pos.z,
            function(obj)
                obj.oBehParams2ndByte = 0
                obj.oOpacity = 255
                obj.oFlags = OBJ_FLAG_HOLDABLE
                obj.oInteractType = obj.oInteractType | INTERACT_GRABBABLE
            end)
        if obj ~= nil then
            m.usedObj = obj
            mario_grab_used_object(m)
            m.marioBodyState.grabPos = GRAB_POS_LIGHT_OBJ
            set_mario_action(m, ACT_HOLD_IDLE, 0)
        end 
                           Walletamount = Walletamount - 12
       
                       else
                           play_character_sound(m,  CHAR_SOUND_DOH)
                       end
elseif Currentselecteditem == 8 then
    if Walletamount >= 15 then
        -- spawn flyguy
        spawn_sync_object(
           id_bhvFlyGuy,
           E_MODEL_FLYGUY,
           m.pos.x + 150, m.pos.y, m.pos.z,
           nil)

              
          Walletamount = Walletamount - 15

      else
          play_character_sound(m,  CHAR_SOUND_DOH)
      end          
elseif Currentselecteditem == 9 then
    if Walletamount >= 16 then
        -- spawn boo         
        spawn_sync_object(
            id_bhvBoo,
            E_MODEL_BOO,
            m.pos.x + 150, m.pos.y, m.pos.z,
            nil)
       
                            Walletamount = Walletamount - 16
                        else
                            play_character_sound(m,  CHAR_SOUND_DOH)
                        end
elseif Currentselecteditem == 10 then


if Walletamount >= 18 then
         -- spawn monkey 

         spawn_sync_object(
            id_bhvUkiki,
            E_MODEL_UKIKI,
            m.pos.x + 150, m.pos.y, m.pos.z,
            nil)
                




    Walletamount = Walletamount - 18
else
    play_character_sound(m,  CHAR_SOUND_DOH)
end
              
elseif Currentselecteditem == 11 then
                          --shell
                          if Walletamount >= 20 then
                            -- spawn shell
                            spawn_sync_object(
                             id_bhvKoopaShell,
                             E_MODEL_KOOPA_SHELL,
                             m.pos.x + 150, m.pos.y, m.pos.z,
                             nil)   
                                        Walletamount = Walletamount - 20
                    
                                    else
                                        play_character_sound(m,  CHAR_SOUND_DOH)
                                    end
elseif Currentselecteditem == 12 then
    -- mini mario
    if Walletamount >= 22 then    
        minimarioTimer = minimarioDuration  -- Reset the timer to 30 seconds
        BigmarioTimer = 0
        m.health = 0x880


                       Walletamount = Walletamount - 22
                   else
                       play_character_sound(m,  CHAR_SOUND_DOH)
                   end           
elseif Currentselecteditem == 13 then
               -- spawn 1up
               if Walletamount >= 25 then    
    
                --   E_MODEL_YOSHI_EGG,
               spawn_sync_object(
                   id_bhv1Up,
                   E_MODEL_1UP,
                   m.pos.x, m.pos.y, m.pos.z,
                   nil)
   
        
   
                               Walletamount = Walletamount - 25
                           else
                               play_character_sound(m,  CHAR_SOUND_DOH)
                           end       
elseif Currentselecteditem == 14 then
       --metal
       if Walletamount >= 30 then
        m.flags = m.flags | MARIO_METAL_CAP
        m.captimer =  1600  
                Walletamount = Walletamount - 30

            else
                play_character_sound(m,  CHAR_SOUND_DOH)
            end       
elseif Currentselecteditem == 15 then
           --vanish
           if Walletamount >= 35 then  
            m.flags = m.flags | MARIO_VANISH_CAP ---giving mario vanish cap
            m.captimer = 1600 
               Walletamount = Walletamount - 35
           else
               play_character_sound(m,  CHAR_SOUND_DOH)
           end  
elseif Currentselecteditem == 16 then
             --Wing
             if Walletamount >= 40 then
                m.flags = m.flags | MARIO_WING_CAP ---give wing cap
                m.captimer =  1600  
                           Walletamount = Walletamount - 40
                       else
                           play_character_sound(m,  CHAR_SOUND_DOH)
                       end              
elseif Currentselecteditem == 17 then
    if Walletamount >= 45 then
        --Giant Mario
        m.health = 0x880
        BigmarioTimer = BigmarioDuration  -- Reset the timer to 30 seconds
        minimarioTimer = 0
                      Walletamount = Walletamount - 45
                  else
                      play_character_sound(m,  CHAR_SOUND_DOH)
                  end         
elseif Currentselecteditem == 18 then
 --Ball
 if Walletamount >= 45 then
    -- spawn ball
    spawn_sync_object(
       id_bhvBall,
       E_MODEL_SPINY_BALL,
       m.pos.x + 150, m.pos.y, m.pos.z,
       nil)       
                  Walletamount = Walletamount - 45
              else
                  play_character_sound(m,  CHAR_SOUND_DOH)
              end        
elseif Currentselecteditem == 19 then
    if Walletamount >= 50  and Moonjumpactive == false then   
        
           
        --Moon Jump
        Moonjumpactive = true
        set_mario_action(m, ACT_DOUBLE_JUMP, 0)
        m.particleFlags = PARTICLE_SPARKLES | PARTICLE_DUST
    
    
    
    
    
           
                                Walletamount = Walletamount - 50
                            else
                                play_character_sound(m,  CHAR_SOUND_DOH)
                            end  
elseif Currentselecteditem == 20 then
    if Walletamount >= 55 then   
        

        spawn_sync_object(
        --chill Bully
            id_bhvSmallBully,
            E_MODEL_CHILL_BULLY,
            m.pos.x + 150, m.pos.y, m.pos.z,
            nil)
        


                            Walletamount = Walletamount - 55
                        else
                            play_character_sound(m,  CHAR_SOUND_DOH)
                        end
   
elseif Currentselecteditem == 21 then
    if Walletamount >= 60 then      
        -- spawn Penguin
  spawn_sync_object(
      id_bhvSmallPenguin,
      E_MODEL_PENGUIN,
      m.pos.x + 150, m.pos.y, m.pos.z,
      nil)  


 
                      Walletamount = Walletamount - 60
                  else
                      play_character_sound(m,  CHAR_SOUND_DOH)
                  end

elseif Currentselecteditem == 22 then
    if Walletamount >= 80 then       


        -- spawn piano
        
        spawn_sync_object(
          id_bhvMadPiano,
          E_MODEL_MAD_PIANO,
          m.pos.x + 200, m.pos.y, m.pos.z,
          nil)
  
       
         
                              Walletamount = Walletamount - 80
                          else
                              play_character_sound(m,  CHAR_SOUND_DOH)
                          end
           
                elseif Currentselecteditem == 23 then  
                    if Walletamount >= 500 then
                        spawn_sync_object(
                            id_bhvBowser,
                            E_MODEL_BOWSER,
                            m.pos.x + 150, m.pos.y + 200, m.pos.z,
                            nil)
                       
                            Walletamount = Walletamount - 500
                                       
                        else
                                          play_character_sound(m,  CHAR_SOUND_MAMA_MIA)
                    end
                    
                elseif Currentselecteditem == 24 then


                   -- Win the game!!!
                   
                   if Walletamount >= 1000 then
                    set_mario_action(m, ACT_END_WAVING_CUTSCENE, 0)
                                   Walletamount = Walletamount - 1000
               
                 else
                                   play_character_sound(m,  CHAR_SOUND_MAMA_MIA)
                end
                   
                               
                   
end                
   











end                      
end




function mario_update_local(m)

	SpawnItem(m)
    Storemenu(m)
    if (m.controller.buttonPressed & L_TRIG) ~= 0 then
        
        if  shopisopen == false then
        shopisopen = true
        else
        
        shopisopen = false
        end
    end

end

function mario_update(m)
    if m.playerIndex == 0 then
        mario_update_local(m)
    end
end



---@param m MarioState 
---@param o Object
local function MarioCoinGet(m, o,interactType)
    if (m.playerIndex ~= 0) then
        return
    else
        if interactType == INTERACT_COIN and (o.oDamageOrCoinValue > 0) then --checking that a coin was interacted with
            Walletamount = Walletamount + o.oDamageOrCoinValue --increasing the ringcount variable
        end

        if interactType == INTERACT_STAR_OR_KEY then
            Walletamount = Walletamount + 50
        end


        
    end
end


function big_mario_instant_kill(m)
    if m.action == ACT_FLAG_ON_POLE or m.action == ACT_CLIMBING_POLE or m.action == ACT_GRAB_POLE_FAST or m.action == ACT_GRAB_POLE_SLOW  and justtouchedtree  then
        set_mario_action(m, ACT_FLAG_AIR, 0)
        justtouchedtree = false
    end

    local targets = {
        id_bhvGoomba, id_bhvBobomb, id_bhvKoopa, id_bhvFlyGuy, id_bhvMontyMole,
        id_bhvSpindrift, id_bhvBoo, id_bhvGhostHuntBoo, id_bhvBooInCastle, id_bhvBooWithCage,
        id_bhvMerryGoRoundBoo, id_bhvFlyingBookend, id_bhvSkeeter, id_bhvMoneybag, id_bhvSnufit,
        id_bhvSwoop, id_bhvEnemyLakitu, id_bhvSpiny, id_bhvPokey, id_bhvPokeyBodyPart,
        id_bhvFirePiranhaPlant, id_bhvBigBoulder, id_bhvGhostHuntBigBoo, id_bhvMerryGoRoundBigBoo,
        id_bhvChainChomp, id_bhvBreakableBox, id_bhvWigglerHead, id_bhvStarDoor,
        id_bhvHeaveHo, id_bhvSmallBully, id_bhvBigBully, id_bhvSmallChillBully, id_bhvBigChillBully,
        id_bhvPitBowlingBall, id_bhvPiranhaPlant, id_bhvBulletBill, id_bhvChuckya,
        id_bhvWhompKingBoss, id_bhvSignOnWall, id_bhvTree, id_bhvBowlingBall, id_bhvFreeBowlingBall,
        id_bhvBobombBuddy, id_bhvWoodenPost, id_bhvScuttlebug, id_bhvCannonBarrel, id_bhvMrI, id_bhvHomingAmp,
        id_bhvCannonBarrelBubbles, id_bhvCannonBarrel, id_bhvCirclingAmp, id_bhvBobombBuddyOpensCannon,
        id_bhvFireSpitter, id_bhvMessagePanel, id_bhvExclamationBox, id_bhvChainChompGate
    }
    
    for _, target_behavior in ipairs(targets) do
        local target = cur_obj_nearest_object_with_behavior(get_behavior_from_id(target_behavior))
        if target ~= nil and obj_check_hitbox_overlap(m.marioObj, target) then
            if target_behavior == id_bhvSmallBully or target_behavior == id_bhvBigBully or target_behavior == id_bhvSmallChillBully or target_behavior == id_bhvBigChillBully then
                target.oInteractStatus = target.oInteractStatus | ATTACK_FAST_ATTACK | INT_STATUS_WAS_ATTACKED | INT_STATUS_INTERACTED | ATTACK_FROM_ABOVE
                target.oForwardVel = 100
                target.oAction = 8
                target.oVelY = 30
            elseif target_behavior == id_bhvBreakableBox or target_behavior == id_bhvExclamationBox then
                target.oInteractStatus = target.oInteractStatus | ATTACK_FAST_ATTACK | INT_STATUS_WAS_ATTACKED | INT_STATUS_INTERACTED | ATTACK_FROM_ABOVE
            elseif target_behavior == id_bhvHomingAmp or target_behavior == id_bhvCirclingAmp or target_behavior == id_bhvHeaveHo or target_behavior == id_bhvFireSpitter then

             

                spawn_mist_particles_with_sound(SOUND_GENERAL_BREAK_BOX)
                obj_mark_for_deletion(target)

            elseif target_behavior == id_bhvMessagePanel or target_behavior == id_bhvBigBoulder or target_behavior == id_bhvWoodenPost then

                spawn_mist_particles_with_sound(SOUND_GENERAL_BREAK_BOX)
                obj_mark_for_deletion(target)

            elseif target_behavior == id_bhvTree then
                spawn_mist_particles_with_sound(SOUND_GENERAL_BREAK_BOX)
                obj_mark_for_deletion(target)
          
              justtouchedtree = true
            elseif target_behavior == id_bhvBobomb or target_behavior == id_bhvBobombBuddy or target_behavior == id_bhvBobombBuddyOpensCannon or target_behavior == id_bhvPitBowlingBall then
                spawn_mist_particles_with_sound(SOUND_GENERAL2_BOBOMB_EXPLOSION)
                obj_mark_for_deletion(target)
            elseif target_behavior == id_bhvChainChomp then
                target.oInteractStatus = target.oInteractStatus | ATTACK_FAST_ATTACK | INT_STATUS_WAS_ATTACKED | INT_STATUS_INTERACTED | INT_STATUS_TOUCHED_BOB_OMB
            elseif target_behavior == id_bhvChainChompGate then 
                spawn_mist_particles_with_sound(SOUND_GENERAL2_BOBOMB_EXPLOSION)
                obj_mark_for_deletion(target)  
            elseif target_behavior == id_bhvFreeBowlingBall then

                target.oInteractStatus = target.oInteractStatus | ATTACK_FAST_ATTACK | INT_STATUS_WAS_ATTACKED | INT_STATUS_INTERACTED | INT_STATUS_TOUCHED_BOB_OMB
                target.oMoveAngleYaw = m.marioObj.oMoveAngleYaw
                target.oForwardVel = 100
                target.oAction = 8
                target.oVelY = 30
                spawn_mist_particles_with_sound(SOUND_GENERAL2_BOBOMB_EXPLOSION)
                obj_mark_for_deletion(target)
            else
                target.oInteractStatus = target.oInteractStatus | ATTACK_FAST_ATTACK | INT_STATUS_WAS_ATTACKED | INT_STATUS_INTERACTED | INT_STATUS_TOUCHED_BOB_OMB
                target.oMoveAngleYaw = m.marioObj.oMoveAngleYaw
                target.oForwardVel = 100
                target.oAction = 8
                target.oVelY = 30
            end
        end
    end
end



local function test_text()
    -- set text and scale


    local adjustx = 60

    -- set location
    local x = 860
    local y = 940

    if Currentselecteditem == 0 then
        pricetext = "0"
         adjustx = 60
    elseif Currentselecteditem == 1 then   
        pricetext = "1"
        adjustx = 60
    elseif Currentselecteditem == 2 then

   
        pricetext = "3"
     adjustx = 60
    elseif Currentselecteditem == 3 then
   
   
        pricetext = "5"
     adjustx = 60
    elseif Currentselecteditem == 4 then
    
      
        pricetext = "8"
         adjustx = 60
    elseif Currentselecteditem == 5 then
     
       
        pricetext = "10"
         adjustx = 45
    elseif Currentselecteditem == 6 then
   
      
        pricetext = "10"
        adjustx = 45
    elseif Currentselecteditem == 7 then
       
        pricetext = "12"
       adjustx = 45
    elseif Currentselecteditem == 8 then
    

        pricetext = "15"
     adjustx = 45
    elseif Currentselecteditem == 9 then
        

        pricetext = "16"

       adjustx = 45
    elseif Currentselecteditem == 10 then
    
        pricetext = "18"
    adjustx = 45
    elseif Currentselecteditem == 11 then
   
        pricetext = "20"
    adjustx = 45
    elseif Currentselecteditem == 12 then
        pricetext = "22"
        adjustx = 45
    
    elseif Currentselecteditem == 13 then
      
        pricetext = "25"
        adjustx = 45
    elseif Currentselecteditem == 14 then
       
        pricetext = "30"
        adjustx = 45 
    elseif Currentselecteditem == 15 then
        pricetext = "35"
        adjustx = 45
    elseif Currentselecteditem == 16 then
        pricetext = "40"
        adjustx = 45
    elseif Currentselecteditem == 17 then
        pricetext = "45"
        adjustx = 45
    elseif Currentselecteditem == 18 then
        pricetext = "45"
        adjustx = 45
    elseif Currentselecteditem == 19 then
        pricetext = "50"
        adjustx = 45
    elseif Currentselecteditem == 20 then
        pricetext = "55"
        adjustx = 45
    elseif Currentselecteditem == 21 then
        pricetext = "60"
        adjustx = 45
    elseif Currentselecteditem == 22 then
        pricetext = "80"
        adjustx = 45
      
    elseif Currentselecteditem == 23 then
        pricetext = "500"
        adjustx = 35
    elseif Currentselecteditem == 24 then
        pricetext = "1000"
        adjustx = 20

    end







    local scale = 1

    -- render to native screen space, with the MENU font
    djui_hud_set_resolution(RESOLUTION_DJUI)
    djui_hud_set_font(FONT_MENU)

    -- get width of screen and text
    local screenWidth = djui_hud_get_screen_width()
    local width = djui_hud_measure_text(pricetext) * scale

    -- get height of screen and text
    local screenHeight = djui_hud_get_screen_height()
    local height = 64 * scale



    -- set color and render
    djui_hud_set_color(255, 0, 0, 255)
    djui_hud_print_text(pricetext, x + adjustx, y, scale)
end

local function test_texture()

    local x = 860
    local y = 745

    if Currentselecteditem == 0 then
        
        CurrentTexture = get_texture_info('Storeitem0')
    elseif Currentselecteditem == 1 then
       
        CurrentTexture = get_texture_info('Storeitem1')
    elseif Currentselecteditem == 2 then
   
    CurrentTexture = get_texture_info('Storeitem2')
    elseif Currentselecteditem == 3 then
   
    CurrentTexture = get_texture_info('Storeitem3')
    elseif Currentselecteditem == 4 then
       
        CurrentTexture = get_texture_info('Storeitem4')

    elseif Currentselecteditem == 5 then
        
        CurrentTexture = get_texture_info('Storeitem5')
    elseif Currentselecteditem == 6 then
        
        CurrentTexture = get_texture_info('Storeitem6')
    elseif Currentselecteditem == 7 then
        
        CurrentTexture = get_texture_info('Storeitem7')
    elseif Currentselecteditem == 8 then
    

    CurrentTexture = get_texture_info('Storeitem8')

    elseif Currentselecteditem == 9 then
        

        CurrentTexture = get_texture_info('Storeitem9')


    elseif Currentselecteditem == 10 then
  
    CurrentTexture = get_texture_info('Storeitem10')
    elseif Currentselecteditem == 11 then
  
    CurrentTexture = get_texture_info('Storeitem11')
    elseif Currentselecteditem == 12 then
      
        CurrentTexture = get_texture_info('Storeitem12')
    elseif Currentselecteditem == 13 then
      

        CurrentTexture = get_texture_info('Storeitem13')
    elseif Currentselecteditem == 14 then
        
        CurrentTexture = get_texture_info('Storeitem14')

    elseif Currentselecteditem == 15 then
   
        CurrentTexture = get_texture_info('Storeitem15')

    elseif Currentselecteditem == 16 then
        CurrentTexture = get_texture_info('Storeitem16')
    elseif Currentselecteditem == 17 then
        CurrentTexture = get_texture_info('Storeitem17')
    elseif Currentselecteditem == 18 then
        CurrentTexture = get_texture_info('Storeitem18')
    elseif Currentselecteditem == 19 then
        CurrentTexture = get_texture_info('Storeitem19')
    elseif Currentselecteditem == 20 then
        CurrentTexture = get_texture_info('Storeitem20')
    elseif Currentselecteditem == 21 then
        CurrentTexture = get_texture_info('Storeitem21')
    elseif Currentselecteditem == 22 then
        CurrentTexture = get_texture_info('Storeitem22')


    end





    -- render to the N64's screen space
    djui_hud_set_resolution(RESOLUTION_DJUI)



    -- color and render
    djui_hud_set_color(255, 255, 255, 255)
    djui_hud_render_texture(CurrentTexture, x, y, 10, 10)

end

local function test_rect()
    if shopisopen == true then
    -- render to native screen space
    djui_hud_set_resolution(RESOLUTION_DJUI)

    -- set location
    local x = 812
    local y = 700

    -- set width/height
    local w = 256
    local h = 256

    -- set color and render first rectangle
    djui_hud_set_color(0, 0, 0, 128)
    djui_hud_render_rect(x, y, w, h)

    -- adjust location and size
    x = x + 16
    y = y + 16
    w = w - 32
    h = h - 32

    -- set color and render second rectangle
    djui_hud_set_color(150, 0, 255, 128)
    djui_hud_render_rect(x, y, w, h)

    -- adjust location and size
    x = x + 16
    y = y + 16
    w = w - 32
    h = h - 32

    -- set color and render third rectangle
    djui_hud_set_color(0, 255, 0, 128)
    djui_hud_render_rect(x, y, w, h)
    end
end
local function walletamnt_text()
    -- set text and scale
    local text = tostring(Walletamount)

    local adjustx = 60

    -- set location
    local x = 60
    local y = 115







    local scale = 2

    -- render to native screen space, with the MENU font
    djui_hud_set_resolution(RESOLUTION_DJUI)
    djui_hud_set_font(FONT_MENU)

    -- get width of screen and text
    local screenWidth = djui_hud_get_screen_width()
    local width = djui_hud_measure_text(text) * scale

    -- get height of screen and text
    local screenHeight = djui_hud_get_screen_height()
    local height = 64 * scale



    -- set color and render
    djui_hud_set_color(0, 255, 0, 255)
    djui_hud_print_text(text, x + adjustx, y, scale)
end






-- HOOK_ON_HUD_RENDER renders above SM64's hud
local function on_hud_render()
    walletamnt_text()
if shopisopen == true then

    test_text()

    test_texture()
    
  
end 
   
end

-- HOOK_ON_HUD_RENDER_BEHIND renders behind SM64's hud
function bhv_ball_init(obj)
    obj.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj.oGraphYOffset = 35
    cur_obj_scale(1.0)

    -- physics
    obj.oWallHitboxRadius = 40.00
    obj.oGravity          =  2.50
    obj.oBounciness       = -0.75
    obj.oDragStrength     =  0.00
    obj.oFriction         =  0.99
    obj.oBuoyancy         =  -2.00

    -- hitbox
    obj.hitboxRadius = 100
    obj.hitboxHeight = 100

    network_init_object(obj, true, nil)
end

function bhv_ball_loop(obj)
    local m = nearest_mario_state_to_object(obj)
    local player = m.marioObj
    local distanceToPlayer = dist_between_objects(obj, player)
    local angleToPlayer = obj_angle_to_object(obj, player)
    local localPlayerTouch = false

    -- figure out player-to-ball radius
    local radius = 100
    if (m.action & ACT_FLAG_ATTACKING) ~= 0 then
        radius = 150
    end

    -- check if player should affect ball
    if distanceToPlayer < radius then
        local xdiff = player.oPosX - obj.oPosX
        local zdiff = player.oPosZ - obj.oPosZ

        obj.oPosX = obj.oPosX - (radius - distanceToPlayer) / radius * xdiff;
        obj.oPosZ = obj.oPosZ - (radius - distanceToPlayer) / radius * zdiff;

        obj.oMoveAngleYaw = angleToPlayer + 0x8000
        obj.oForwardVel = obj.oForwardVel + 10

        if (m.action & ACT_FLAG_ATTACKING) ~= 0 then
            obj.oVelY = obj.oVelY + 20.0
        end
        if m.playerIndex == 0 then
            localPlayerTouch = true
        end
    end

    -- do physics
    local stepRc = object_step_without_floor_orient()

    -- play sounds
    if stepRc == 1 then
        cur_obj_play_sound_2(SOUND_GENERAL_BOX_LANDING_2)
    elseif (stepRc & 1) ~= 0 then
        if obj.oForwardVel > 20.0 then
            cur_obj_play_sound_2(SOUND_ENV_SLIDING)
        end
    end

    -- check for floor death
    local floor = cur_obj_update_floor_height_and_get_floor()
    if floor ~= nil then
        obj_check_floor_death(stepRc, floor)
    end

    -- update visual rotation
    obj.oFaceAngleYaw = obj.oMoveAngleYaw
    obj.oFaceAnglePitch = obj.oFaceAnglePitch + obj.oForwardVel * 100

    -- if we touched it, send an immediate update instead of waiting
    if localPlayerTouch then
        network_send_object(obj, false)
    end
end

define_custom_obj_fields({
    oCustomGoombaScale = 'f32',
    oCustomGoombaTargetYaw = 'f32',
    oCustomGoombaRelativeSpeed = 'f32',
})

function bhv_custom_goomba_init(obj)
    -- set flags
    obj.oFlags = (OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_COMPUTE_DIST_TO_MARIO | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE)

    -- drop to floor
    local x = obj.oPosX
    local y = obj.oPosY
    local z = obj.oPosZ
    local floor = find_floor_height(x, y + 200.0, z)
    obj.oPosY = floor
    obj.oMoveFlags = obj.oMoveFlags | OBJ_MOVE_ON_GROUND

    -- animations
    obj.oAnimations = gObjectAnimations.goomba_seg8_anims_0801DA4C

    -- home
    obj.oHomeX = obj.oPosX
    obj.oHomeY = obj.oPosY
    obj.oHomeZ = obj.oPosZ

    -- physics
    obj.oWallHitboxRadius = 40.0
    obj.oGravity          = -4.0
    obj.oBounciness       = -0.5
    obj.oDragStrength     = 10.0
    obj.oFriction         = 10.0
    obj.oBuoyancy         =  0.0

    -- normal init
    obj.oCustomGoombaScale = 1.5
    obj.oDeathSound = SOUND_OBJ_ENEMY_DEATH_HIGH

    -- hitbox
    obj.oInteractType = INTERACT_BOUNCE_TOP
    obj.oHealth = 0
    obj.oNumLootCoins = 1
    obj.oIntangibleTimer = 0
    obj.hitboxRadius = obj.header.gfx.scale.x * 72
    obj.hitboxHeight = obj.header.gfx.scale.y * 50
    obj.hurtboxRadius = obj.header.gfx.scale.x * 42
    obj.hurtboxHeight = obj.header.gfx.scale.y * 40
    obj.hitboxDownOffset = obj.header.gfx.scale.y * 0

    -- other flags
    obj.oDrawingDistance = 4000
    obj.oDamageOrCoinValue = 1
    obj.oGravity = -8.0 / 3.0 * obj.oCustomGoombaScale

    -- start synchronizing object
    network_init_object(obj, true, {
        'oCustomGoombaScale',
        'oCustomGoombaTargetYaw',
        'oCustomGoombaRelativeSpeed',
    })
end

function bhv_custom_goomba_loop(obj)
    -- find player
    local player = nearest_player_to_object(obj)
    local distanceToPlayer = dist_between_objects(obj, player)
    local angleToPlayer = obj_angle_to_object(obj, player)

    -- animate
    cur_obj_init_animation_with_accel_and_sound(0, 5.0)

    -- update floor/walls and rotation
    cur_obj_update_floor_and_walls()
    obj.oCustomGoombaTargetYaw = angleToPlayer
    cur_obj_rotate_yaw_toward(obj.oCustomGoombaTargetYaw, 0x200)

    -- set velocity
    obj.oCustomGoombaRelativeSpeed = 80.0
    obj_forward_vel_approach(obj.oCustomGoombaRelativeSpeed * obj.oCustomGoombaScale, 0.4)

    -- perform physics
    cur_obj_move_standard(-78)

    -- if goomba interacts, kill it
    if (obj.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
        obj_mark_for_deletion(obj)
    end
end


function howtouse(msg)
    djui_chat_message_create("Press L to Open Coin Store. While the store is open usel Dpad L and R to Cycle. Press the D pad Down to buy and Item at any time")
    return true
    
  end








-- hooks --

id_bhvCustomGoomba = hook_behavior(nil, OBJ_LIST_PUSHABLE, true, bhv_custom_goomba_init, bhv_custom_goomba_loop)
id_bhvBall = hook_behavior(nil, OBJ_LIST_DEFAULT, true, bhv_ball_init, bhv_ball_loop)
hook_event(HOOK_ON_HUD_RENDER, on_hud_render)
hook_event(HOOK_ON_HUD_RENDER_BEHIND, test_rect)
hook_event(HOOK_ON_INTERACT, MarioCoinGet) --hook for interacting with coins
hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_PLAYER_CONNECTED, howtouse)
